package com.jiuqi.grid;

import java.io.Serializable;

public class CellDataProperty implements CellDataPropertyIntf, Serializable {
   private byte dataType;
   private byte dataFlag;
   private byte editMode;
   private byte dataFormat;
   private short dataProperty;
   private GridCell cell;

   public CellDataProperty(GridCell cell) {
      if (cell == null) {
         throw new IllegalArgumentException("传入的cell为null");
      } else {
         this.cell = cell;
      }
   }

   public CellDataProperty(int dataType, int dataFlag, int editMode, int dataFormat, int dataProperty) {
      this.dataType = (byte)dataType;
      this.dataFlag = (byte)dataFlag;
      this.editMode = (byte)editMode;
      this.dataFormat = (byte)dataFormat;
      this.dataProperty = (short)dataProperty;
   }

   public byte getDataType() {
      return this.cell != null ? (byte)this.cell.getDataType() : this.dataType;
   }

   public void setDataType(byte value) {
      if (value >= 0 && value <= 11) {
         if (this.cell != null) {
            this.cell.setDataType(value);
         }

         this.dataType = value;
      } else {
         throw new IllegalArgumentException("单元格数据类型被错误设置！");
      }
   }

   public byte getDataFlag() {
      return this.cell != null ? (byte)this.cell.getDataFlag() : this.dataFlag;
   }

   public void setDataFlag(byte value) {
      if (this.cell != null) {
         this.cell.setDataFlag(value);
      }

      this.dataFlag = value;
   }

   public byte getEditMode() {
      return this.cell != null ? (byte)this.cell.getEditMode() : this.editMode;
   }

   public void setEditMode(byte value) {
      if (value >= 0 && value <= 9) {
         if (this.cell != null) {
            this.cell.setEditMode(value);
         }

         this.editMode = value;
      } else {
         throw new IllegalArgumentException("单元格编辑模式被错误设置！");
      }
   }

   public byte getDataFormat() {
      return this.cell != null ? (byte)this.cell.getDataFormat() : this.dataFormat;
   }

   public void setDataFormat(byte value) {
      if (this.cell != null) {
         this.cell.setDataFormat(value);
      }

      this.dataFormat = value;
   }

   public short getDataProperty() {
      return this.cell != null ? (short)this.cell.getDataProperty() : this.dataProperty;
   }

   public void setDataProPerty(short value) {
      if (this.cell != null) {
         this.cell.setDataProperty(value);
      }

      this.dataProperty = value;
   }
}
